/*ident	"@(#)C++env:incl-master/proto-headers/math.h	1.2" */

#ifndef __MATH_H
#ifndef _PARAMS
#if defined(__STDC__) || defined(__cplusplus)
#define _PARAMS(ARGS) ARGS
#else
#define _PARAMS(ARGS) ()
#endif
#endif /* _PARAMS */
#ifndef _PARAMS
#if defined(__STDC__) || defined(__cplusplus)
#define _PARAMS(ARGS) ARGS
#else
#define _PARAMS(ARGS) ()
#endif
#endif /* _PARAMS */
#define __MATH_H

#define arc ______arc
#define line ______line
#define space ______space
#define asinh ______asinh
#define acosh ______acosh
#define atanh ______atanh
#define atof ______atof
#define exp ______exp
#define expm1 ______expm1
#define log ______log
#define log10 ______log10
#define log1p ______log1p
#define pow ______pow
#define hypot ______hypot
#define cabs ______cabs
#define cbrt ______cbrt
#define sqrt ______sqrt
#define lgamma ______lgamma
#define gamma ______gamma
#define matherr ______matherr
#define fabs ______fabs
#define floor ______floor
#define ceil ______ceil
#define rint ______rint
#define copysign ______copysign
#define drem ______drem
#define logb ______logb
#define scalb ______scalb
#define finite ______finite
#define sinh ______sinh
#define cosh ______cosh
#define tanh ______tanh
#define sin ______sin
#define cos ______cos
#define tan ______tan
#define asin ______asin
#define acos ______acos
#define atan ______atan
#define atan2 ______atan2
#define frexp ______frexp
#define ldexp ______ldexp
#define modf ______modf
#define strtod ______strtod
#define erf ______erf
#define erfc ______erfc
#define j0 ______j0
#define j1 ______j1
#define jn ______jn
#define y0 ______y0
#define y1 ______y1
#define yn ______yn

/* --------------------------------------------------- */
/* | Copyright (c) 1986 MIPS Computer Systems, Inc.  | */
/* | All Rights Reserved.                            | */
/* --------------------------------------------------- */
/* $Header: math.h,v 1.9 88/01/22 11:23:18 dce Exp $ */

#ifndef	_MATH_
#define	_MATH_	1


#ifndef _POLY9
extern int errno, signgam;

/* features from sys v */

extern double fmod(), gamma();
extern int matherr();

/* features from 4.3 BSD */

extern double asinh(double), acosh(double), atanh(double);
extern double erf(double), erfc(double);
extern double exp(double), expm1(double);
extern double log(double), log10(double), log1p(double), pow(double, double);
extern double fabs(double), floor(double), ceil(double), rint(double);
extern double lgamma(double);
extern double hypot(double, double), cabs(/*struct {double; double}*/);
extern double copysign(double, double), drem(double, double);
extern double logb(double), scalb(double, int);
extern int finite(double);
extern double j0(double), j1(double), jn(int, double);
extern double y0(double), y1(double), yn(int, double);
extern double sin(double), cos(double), tan(double);
extern double asin(double), acos(double), atan(double), atan2(double, double);
extern double sinh(double), cosh(double), tanh(double);
extern double cbrt(double), sqrt(double);
extern double modf(double, double *);
extern double ldexp(double, int), frexp(double, int *);
extern double atof(char *);

/* MIPS single-precision forms */

/*extern float fasinh(float), facosh(float), fatanh(float);*/
/*extern float ferf(float), ferfc(float);*/
extern float fexp(float)/*, fexpm1(float)*/;
extern float flog(float)/*, flog10(float), flog1p(float), fpow(float, float)*/;
extern float /*ffabs(float),*/ ffloor(float), fceil(float)/*, frint(float)*/;
/*extern float flgamma(float);*/
extern float fhypot(float, float) /*, fcabs(struct {float; float}) */;
/*extern float fcopysign(float, float), fdrem(float, float);*/
/*extern float flogb(float), fscalb(float, int);*/
/*extern int ffinite(float);*/
/*extern float fj0(float), fj1(float), fjn(int, float);*/
/*extern float fy0(float), fy1(float), fyn(int, float);*/
extern float fsin(float), fcos(float), ftan(float);
extern float fasin(float), facos(float), fatan(float), fatan2(float, float);
extern float fsinh(float), fcosh(float), ftanh(float);
extern float /*fcbrt(float),*/ fsqrt(float);
/*extern float fmodf(float, float *);*/
/*extern float fldexp(float, int), ffrexp(float, int *);*/
/*extern float fatof(char *);*/

/* some useful constants */
#define M_E	2.7182818284590452354
#define M_LOG2E	1.4426950408889634074
#define M_LOG10E	0.43429448190325182765
#define M_LN2	0.69314718055994530942
#define M_LN10	2.30258509299404568402
#define M_PI	3.14159265358979323846
#define M_PI_2	1.57079632679489661923
#define M_PI_4	0.78539816339744830962
#define M_1_PI	0.31830988618379067154
#define M_2_PI	0.63661977236758134308
#define M_2_SQRTPI	1.12837916709551257390
#define M_SQRT2	1.41421356237309504880
#define M_SQRT1_2	0.70710678118654752440
#define MAXFLOAT	((float)1.701411733192644299e+38)
#define HUGE	MAXFLOAT

#define _ABS(x)	((x) < 0 ? -(x) : (x))
#define _REDUCE(TYPE, X, XN, C1, C2)	{ \
	double x1 = (double)(TYPE)X, x2 = X - x1; \
	X = x1 - (XN) * (C1); X += x2; X -= (XN) * (C2); }
#define _POLY1(x, c)	((c)[0] * (x) + (c)[1])
#define _POLY2(x, c)	(_POLY1((x), (c)) * (x) + (c)[2])
#define _POLY3(x, c)	(_POLY2((x), (c)) * (x) + (c)[3])
#define _POLY4(x, c)	(_POLY3((x), (c)) * (x) + (c)[4])
#define _POLY5(x, c)	(_POLY4((x), (c)) * (x) + (c)[5])
#define _POLY6(x, c)	(_POLY5((x), (c)) * (x) + (c)[6])
#define _POLY7(x, c)	(_POLY6((x), (c)) * (x) + (c)[7])
#define _POLY8(x, c)	(_POLY7((x), (c)) * (x) + (c)[8])
#define _POLY9(x, c)	(_POLY8((x), (c)) * (x) + (c)[9])

struct exception {
	int type;
	char *name;
	double arg1;
	double arg2;
	double retval;
};

#define DOMAIN		1
#define	SING		2
#define	OVERFLOW	3
#define	UNDERFLOW	4
#define	TLOSS		5
#define	PLOSS		6
#endif

#endif
 

#undef y1
#undef arc
#undef expm1
#undef fabs
#undef rint
#undef erfc
#undef copysign
#undef asin
#undef sqrt
#undef frexp
#undef yn
#undef ldexp
#undef gamma
#undef finite
#undef log10
#undef atan2
#undef atan
#undef asinh
#undef acos
#undef lgamma
#undef atanh
#undef cabs
#undef sin
#undef log
#undef ceil
#undef log1p
#undef j0
#undef sinh
#undef hypot
#undef j1
#undef matherr
#undef acosh
#undef tanh
#undef scalb
#undef cbrt
#undef logb
#undef strtod
#undef modf
#undef pow
#undef tan
#undef exp
#undef drem
#undef space
#undef line
#undef cos
#undef jn
#undef floor
#undef atof
#undef erf
#undef y0
#undef cosh

extern "C" {
	double acos(double);
	double asin(double);
	double atan(double);
	double atan2(double, double);
	double atof(const char*);
	double ceil(double);
	double cos(double);
	double cosh(double);
	double erf(double);
	double erfc(double);
	double exp(double);
	double fabs(double);
	double floor(double);
	double frexp(double, int*);
	double gamma(double);
	double hypot(double, double);
	double j0(double);
	double j1(double);
	double jn(int, double);
	double ldexp(double, int);
	double log(double);
	double log10(double);
	double modf(double, double*);
	double pow(double, double);
	double sqrt(double);
	double sin(double);
	double sinh(double);
	double tan(double);
	double tanh(double);
	double y0(double);
	double y1(double);
	double yn(int, double);
	double fmod(double, double);
	int matherr(struct exception*);
	arc(int, int, int, int, int, int);
	line(int, int, int, int);
	space(int, int, int, int);
}

inline int sqr(int x) {return(x*x);}
inline double sqr(double x) {return(x*x);}

inline int abs(int d) { return (d>0)?d:-d; }
inline double abs(double d) { return fabs(d); }

#ifndef M_PI
#define M_PI	3.14159265358979323846
#endif
#ifndef PI
#define PI M_PI
#endif

#endif
