#ifndef _PARAMS
#if defined(__STDC__) || defined(__cplusplus)
#define _PARAMS(ARGS) ARGS
#else
#define _PARAMS(ARGS) ()
#endif
#endif /* _PARAMS */
#define __need___va_list
#include <stdarg.h>
/*
 * |-----------------------------------------------------------|
 * | Copyright (c) 1990 MIPS Computer Systems, Inc.            |
 * | All Rights Reserved                                       |
 * |-----------------------------------------------------------|
 * |          Restricted Rights Legend                         |
 * | Use, duplication, or disclosure by the Government is      |
 * | subject to restrictions as set forth in                   |
 * | subparagraph (c)(1)(ii) of the Rights in Technical        |
 * | Data and Computer Software Clause of DFARS 52.227-7013.   |
 * |         MIPS Computer Systems, Inc.                       |
 * |         928 Arques Avenue                                 |
 * |         Sunnyvale, CA 94086                               |
 * |-----------------------------------------------------------|
 */
/* $Header: stdio.h,v 1.10.3.6 90/05/10 01:04:14 wje Exp $ */

#ifndef	_STDIO_
#define	_STDIO_	1


/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ifndef _NFILE
#define _NFILE	100

#if __mips__
#define BUFSIZ	4096
#endif
#if __u370__
#define BUFSIZ	4096
#endif
#if __vax__ || __u3b__ || __M32__ || __u3b15__ || __u3b5__ || __u3b2__
#define BUFSIZ	1024
#endif
#if __pdp11__
#define BUFSIZ	512
#endif

/* buffer size for multi-character output to unbuffered files */
#define _SBFSIZ 8

typedef struct {
#if __vax__ || __u3b__ || __M32__ || __u3b15__ || __u3b5__ || __u3b2__ || __mips__
	int	_cnt;
	unsigned char	*_ptr;
#else
	unsigned char	*_ptr;
	int	_cnt;
#endif
	unsigned char	*_base;
	char	_flag;
	char	_file;
} FILE;

/*
 * _IOLBF means that a file's output will be buffered line by line
 * In addition to being flags, _IONBF, _IOLBF and _IOFBF are possible
 * values for "type" in setvbuf.
 */
#define _IOFBF		0000
#define _IOREAD		0001
#define _IOWRT		0002
#define _IONBF		0004
#define _IOMYBUF	0010
#define _IOEOF		0020
#define _IOERR		0040
#define _IOLBF		0100
#define _IORW		0200

#ifndef NULL
		#undef NULL
#define NULL		0
#endif
#ifndef EOF
#define EOF		(-1)
#endif

#define stdin		(&_iob[0])
#define stdout		(&_iob[1])
#define stderr		(&_iob[2])

#define _bufend(p)	_bufendtab[(p)->_file]
#define _bufsiz(p)	(_bufend(p) - (p)->_base)

#ifndef lint
#define getc(p)		(--(p)->_cnt < 0 ? _filbuf(p) : (int) *(p)->_ptr++)
#define putc(x, p)	(--(p)->_cnt < 0 ? \
			_flsbuf((unsigned char) (x), (p)) : \
			(int) (*(p)->_ptr++ = (unsigned char) (x)))
#define getchar()	getc(stdin)
#define putchar(x)	putc((x), stdout)
#define clearerr(p)	((void) ((p)->_flag &= ~(_IOERR | _IOEOF)))
#define feof(p)		((p)->_flag & _IOEOF)
#define ferror(p)	((p)->_flag & _IOERR)
#define fileno(p)	(p)->_file
#endif

extern FILE	_iob[];
extern FILE	*fopen _PARAMS((const char *, const char *)), *fdopen _PARAMS((int, const char *)), *freopen _PARAMS((const char *, const char *, FILE *)), *popen _PARAMS((const char *, const char *)), *tmpfile();
extern long	ftell _PARAMS((FILE *));
extern void	rewind _PARAMS((FILE *)), setbuf _PARAMS((FILE *, char *));
extern char	*ctermid _PARAMS((char *)), *cuserid _PARAMS((char *)), *fgets _PARAMS((char *, int, FILE *)), *gets _PARAMS((char *)), *tempnam _PARAMS((const char *, const char *)), *tmpnam _PARAMS((char *));
extern int	fclose _PARAMS((FILE *)), fflush _PARAMS((FILE *)), fread _PARAMS((void *, __SIZE_TYPE__ , __SIZE_TYPE__ , FILE *)), fwrite _PARAMS((const void *, __SIZE_TYPE__ , __SIZE_TYPE__ , FILE *)), fseek _PARAMS((FILE *, long int, int)), fgetc _PARAMS((FILE *)),
		getw _PARAMS((FILE *)), pclose _PARAMS((FILE *)), printf _PARAMS((const char *, ...)), fprintf _PARAMS((FILE *, const char *, ...)), sprintf _PARAMS((char *, const char *, ...)),
		vprintf _PARAMS((const char *, __gnuc_va_list)), vfprintf _PARAMS((FILE *, const char *, __gnuc_va_list)), vsprintf _PARAMS((char *, const char *, __gnuc_va_list)), fputc _PARAMS((int, FILE *)), putw _PARAMS((int, FILE *)),
		puts _PARAMS((const char *)), fputs _PARAMS((const char *, FILE *)), scanf _PARAMS((const char *, ...)), fscanf _PARAMS((FILE *, const char *, ...)), sscanf _PARAMS((const char *, const char *, ...)),
		setvbuf _PARAMS((FILE *, char *, int, __SIZE_TYPE__ )), system _PARAMS((const char *)), ungetc _PARAMS((int, FILE *));

extern unsigned char *_bufendtab[];

#define L_ctermid	9
#define L_cuserid	9
#define P_tmpdir	"/usr/tmp/"
#define L_tmpnam	(sizeof(P_tmpdir) + 15)
#endif

#endif
#if defined(__cplusplus) || defined(__USE_FIXED_PROTOTYPES__)
extern int fgetpos (FILE *, long *);
extern int fsetpos (FILE *, const long *);
extern void perror (const char *);
extern int remove (const char *);
extern int rename (const char *, const char *);
extern int _filbuf (FILE *);
extern int _flsbuf (unsigned int, FILE *);
#endif /* defined(__cplusplus) || defined(__USE_FIXED_PROTOTYPES__*/
